package nl.rug.digitallab.common.kotlin.helpers.smallrye.config

import io.smallrye.config.Priorities
import jakarta.annotation.Priority

/**
 * Implementation of a [FallbacksInterceptor] to handle
 * special property names generated by Kotlin during compilation.
 *
 * This class handles the case of Kotlin Properties: Kotlin produces
 * a getter function for a property in an interface, so for property
 * `foo` there will be the function `getFoo`. Using the normal naming
 * convention for Smallrye, this will be converted to config property
 * `get-foo`. Here, we strip the `get-` prefix - we return all possible
 * combinations of the prefixes being included or stripped anywhere in
 * the path.
 *
 * Note that this is a _fallback_ interceptor, so this will not
 * interfere with normal properties that happen to be prefixed
 * "get-". Smallrye will continue to first try to find the "normal"
 * property name, before trying the modified result from this interceptor.
 *
 * When the name is not resolved properly despite this interceptor,
 * it is best to use the @WithName annotation.
 */
@Priority(Priorities.LIBRARY + 200)
class KotlinPropertyInterceptor : HierarchicalFallbacksInterceptor() {
    override fun getFallbacksForPart(name: String) =
        setOf(name, name.removePrefix("get-"))
}
